require 'Extensions'

path_plug=Sketchup.find_support_file "Plugins"
require File.join(path_plug,'BLB-Bois','Ressources','Menu_BLB-Bois','resource_menu.rb')

	erase_old_versions()
	if (Sketchup.version.to_i < 14) then skp8_plugins_load() end# Sketchup 8 a 2013
		
	if not $blb_bois_zmenu_BLB_Bois_loaded 
		toolbar = UI::Toolbar.new("BLB-Bois")
		
		path_plugins=Sketchup.find_support_file("Plugins") 
		input_f= path_plugins+"/BLB-Bois/Ressources/Menu_BLB-Bois/Menu_BLB-Bois_param.txt"
		
		libelle=[]
		if (f=File.exist?(input_f))
			f= File.open(input_f, "r") 
			f.each do |f_line|
				s=1
				f_line.each_byte {|b| 
					if b==10 then s=s+1 end
					if b==13 then s=s+1 end
				}
				libelle << f_line[0..f_line.length-s]	
			end  # do
			f.close
		end   # file exist
		
		input_f= path_plugins+"/BLB-Bois/Ressources/Langue/Langue_param.txt"
		if File.exist?(input_f)
			f= File.open(input_f,'r') 
			f_line=f.gets
			s=1
			f_line.each_byte {|b| 
				if b==10 then s=s+1 end
				if b==13 then s=s+1 end
			}
			@lgg=f_line[0..f_line.length-s]
			f.close
		else
			@lgg="Français"
		end
		
		msg=[]		
		input_f= path_plugins+"/BLB-Bois/Ressources/Menu_BLB-Bois/Menu_BLB-Bois_messages.txt"		
		
		if (f=File.exist?(input_f))
			f= File.open(input_f, 'r') 
			line=-1
			gap=nil
			nb_languages=1
			range=nil
			f.each do |f_line|
			s=1
			f_line.each_byte {|b| 
				if b==10 then s=s+1 end
				if b==13 then s=s+1 end
			}
			f_line=f_line[0..f_line.length-s]
			if line==-1
				@languages=f_line
				str=@languages
				posi=str.index("|")
				res=str[0..posi-1]
				first_language=res
				str=str[posi+1..str.length-1]
				while posi
					if res==@lgg then range=nb_languages-1 end
					nb_languages=nb_languages+1
					posi=str.index("|")
					if posi
						res=str[0..posi-1]
						str=str[posi+1..str.length-1]
					elsif str==@lgg 
						range=range=nb_languages-1				
					end
				end
				if !range 
					range=0 
					@lgg=first_language
				end
				gap=0
				line=line+1
			elsif range > 0
				range=range-1
			elsif gap > 0
				gap=gap-1
			elsif gap == 0
				gap=nb_languages-1
				msg << f_line
			end
			line=line+1
			end  # do
			f.close
		end   # file exist
		cmd = UI::Command.new("Menu") { UI.openURL("http://www.blb-bois.com/dao") }
		item_generation("BLB-Bois,BLB-Bois,Extensions BLB-Bois,BLB-Bois",cmd,toolbar)

		f_read=path_plugins
		present_plugins=[]
		Dir.foreach(f_read) do |entry|
			file_found=entry
			posi = file_found.index(".rb")
			if !posi then posi = file_found.index(".rbs") end
			if posi then present_plugins << file_found[0..posi-1] end
		end
		
			
		libelle.each {|l|
			lib=""
			l.each_byte {|b| if b >31 then lib<< b end}	
			if lib=="Piece" 
				if present_plugins.index(lib)
					cmd = UI::Command.new("Piece") { 			
						Sketchup.active_model.select_tool Piece_generation.new}
						item_generation(msg[0],cmd,toolbar)	
				end

			elsif lib=="Tenon&Mortaise" 
				if present_plugins.index(lib)
					cmd = UI::Command.new("Tenon") { 
						@@TorM="Tenon" 
						Sketchup.active_model.select_tool Tenon_Mortaise.new}
						item_generation(msg[1],cmd,toolbar)
					# item_generation(["tenon","Tenon","Usiner un tenon","Tenon"],cmd,toolbar)
					cmd = UI::Command.new("Mortaise") {
						@@TorM="Mortaise"
						Sketchup.active_model.select_tool Tenon_Mortaise.new} 
					item_generation(msg[2],cmd,toolbar)	
					cmd = UI::Command.new("Tenon_Mortaise") {
						@@TorM="Tenon_Mortaise" 
						Sketchup.active_model.select_tool Tenon_Mortaise.new} 
					item_generation(msg[3],cmd,toolbar)
				end

			elsif lib=="Usinage" 
				if present_plugins.index(lib)
					cmd = UI::Command.new("Rainure") { 
						@@Usinage="Rainure_Feuillure"
						Sketchup.active_model.select_tool Usinage.new} 
					item_generation(msg[4],cmd,toolbar)	
					cmd = UI::Command.new("Moulure") {
						@@Usinage="Moulure"
						Sketchup.active_model.select_tool Usinage.new}
					item_generation(msg[5],cmd,toolbar)
				end
				
			elsif lib=="Chapeau_gendarme" 
				if present_plugins.index(lib)
					cmd = UI::Command.new("Chapeau_gendarme") {Sketchup.active_model.select_tool Chapeau_gendarme.new} 
					item_generation(msg[6],cmd,toolbar)	
				end

			elsif lib=="Coupe"
				if present_plugins.index(lib)
					cmd = UI::Command.new("Coupe") {Sketchup.active_model.select_tool Coupe_2.new} 
					item_generation(msg[7],cmd,toolbar)		
				end


			elsif lib=="TenonM_renforce"
				if present_plugins.index(lib)
					cmd = UI::Command.new("Tenon_Renfort") {
						@@T_Rep="Tenon"
						Sketchup.active_model.select_tool Tenon_Renfort.new} 
					item_generation(msg[8],cmd,toolbar)		 				
					cmd = UI::Command.new("Tenon_Renfort") {
						@@T_Rep="Tenon_Mortaise"
						Sketchup.active_model.select_tool Tenon_Renfort.new}
					item_generation(msg[9],cmd,toolbar)		 				
				end

			elsif lib=="Fiche_debit"
				if present_plugins.index(lib)
					cmd = UI::Command.new("Fiche debit") {Sketchup.active_model.select_tool Fiche_debit.new} 
					item_generation(msg[10],cmd,toolbar)		 				
				end

			elsif lib=="Rafale_TM"
				if present_plugins.index(lib)
					cmd = UI::Command.new("Simple") {
						@@R_tm="simple"
						Sketchup.active_model.select_tool Rafale_TM.new} 
					item_generation(msg[11],cmd,toolbar)		 				
					cmd = UI::Command.new("Renforce") { Rafale_TM.new
						@@R_tm="renforce"
						Sketchup.active_model.select_tool Rafale_TM.new} 
					item_generation(msg[12],cmd,toolbar)		 				
				end

			elsif lib=="Assemblage"
				if present_plugins.index(lib)
					cmd = UI::Command.new("Lamelle") { 
						@@Assemblage="Lamelle"
						Sketchup.active_model.select_tool Assemblage.new} 
					item_generation(msg[13],cmd,toolbar)
					cmd = UI::Command.new("Domino") {
						@@Assemblage="Domino"
						Sketchup.active_model.select_tool Assemblage.new} 
					item_generation(msg[14],cmd,toolbar)
					cmd = UI::Command.new("Tourillon") { Assemblage.new
						@@Assemblage="Tourillon"
						Sketchup.active_model.select_tool Assemblage.new} 
					item_generation(msg[15],cmd,toolbar)			
					cmd = UI::Command.new("Rainure Languette") { Assemblage.new
						@@Assemblage="R_L"
						Sketchup.active_model.select_tool Assemblage.new } 
					item_generation(msg[16],cmd,toolbar)
					cmd = UI::Command.new("Rainure Fausse Languette") {
						@@Assemblage="R_FL"
						Sketchup.active_model.select_tool Assemblage.new} 
					item_generation(msg[17],cmd,toolbar)
					cmd = UI::Command.new("Queue d'Aronde") {
						@@Assemblage="Aronde"
						Sketchup.active_model.select_tool Assemblage.new } 
					item_generation(msg[18],cmd,toolbar)		
				end
			elsif lib=="Assemblages"	
				if present_plugins.index(lib)				
					cmd = UI::Command.new("Assemblages") {
						@@Assemblage="Lamelle"
						Sketchup.active_model.select_tool Assemblage_2.new} 
					item_generation(msg[19],cmd,toolbar)		 				
				end
	
			elsif lib=="Bouvetage"	
				if present_plugins.index(lib)			
					cmd = UI::Command.new("Bouvetage") {
					@@Bouvetage="R_L"
					Sketchup.active_model.select_tool Bouvetage.new} 
					item_generation(msg[20],cmd,toolbar)		 				 
				end

			elsif lib=="Usinage_contour"
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Usinage_Contour") {
					@@U_c="Rainure"
					Sketchup.active_model.select_tool Usinage_contour.new} 
					item_generation(msg[21],cmd,toolbar)		 				 				   
				end

			elsif lib=="Aqueues"
				if present_plugins.index(lib)
					input_f= File.join(path_plugins,"Aqueues.rb")				
					f= File.open(input_f, "r") 
					text=nil
					f.each do |f_line|
						posi=f_line.index(".version")
						if posi 
							text=f_line[(posi+9)..(f_line.length-2)]
						end
						if text then break end
					end
					f.close
					text=text[4..text.length-2]
					text=text.to_i

					if text >= 2
						cmd = UI::Command.new("Assemblage_queues") {
						Sketchup.active_model.select_tool Aqueues.new} 
						item_generation(msg[22],cmd,toolbar)
					else					
						cmd = UI::Command.new("Queue_Droite") {
							@@T_queue = "Droite"
							Sketchup.active_model.select_tool Aqueues.new} 
						item_generation(msg[23],cmd,toolbar)		 				
						cmd = UI::Command.new("Queue_Aronde") {Aqueues.new
							@@T_queue = "Aronde"
							Sketchup.active_model.select_tool Aqueues.new } 
						item_generation(msg[24],cmd,toolbar)		 				
						cmd = UI::Command.new("Queue_Ronde") {
							@@T_queue = "Ronde"
							Sketchup.active_model.select_tool Aqueues.new } 
						item_generation(msg[25],cmd,toolbar)	
					end
				end
				
			elsif lib=="Systeme_32"
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Systeme 32") {Sketchup.active_model.select_tool Systeme_32.new} 
					item_generation(msg[26],cmd,toolbar)		 				
				end
				
			elsif lib=="Systeme_Kreg"
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Systeme Kreg") {Sketchup.active_model.select_tool Systeme_kreg.new} 
					item_generation(msg[27],cmd,toolbar)		 				
				end		

			elsif lib=="Mise_en_page"
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Mise_en_page") {
						@@Mep="Gen"
						Sketchup.active_model.select_tool Mise_en_page.new} 
					item_generation(msg[28],cmd,toolbar)		 				
				end		

			elsif lib=="Quincaillerie"
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Quincaillerie") {Sketchup.active_model.select_tool Quincaillerie.new} 
					item_generation(msg[29],cmd,toolbar)		 				
				end
				
			elsif lib=="Aboutage"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Aboutage") {Sketchup.active_model.select_tool Aboutage.new} 
					item_generation(msg[30],cmd,toolbar)		 				
				end

			elsif lib=="Percage"						
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Percage") {Sketchup.active_model.select_tool Percage.new} 
					item_generation(msg[31],cmd,toolbar)		 				
				end

			elsif lib=="Caissons"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Caissons") {Sketchup.active_model.select_tool Caissons.new} 
					item_generation(msg[32],cmd,toolbar)		 				
				end
			elsif lib=="Chevillage"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Chevillage") {Sketchup.active_model.select_tool Chevillage.new} 
					item_generation(msg[33],cmd,toolbar)		 				
				end
			elsif lib=="Etire"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Etire") {Sketchup.active_model.select_tool Do_stretching.new} 
					item_generation(msg[34],cmd,toolbar)		 				
				end
			elsif lib=="Vis"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Assemblage_vis") {Sketchup.active_model.select_tool Assemblage_vis.new} 
					item_generation(msg[35],cmd,toolbar)		 				
				end
			elsif lib=="Entaille"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Entaille") {Sketchup.active_model.select_tool Entaille.new} 
					item_generation(msg[36],cmd,toolbar)		 				
				end
			elsif lib=="Bouffetout"				
				if present_plugins.index(lib)	
					cmd = UI::Command.new("Bouffetout") {Sketchup.active_model.select_tool Bouffetout.new} 
					item_generation(msg[37],cmd,toolbar)		 				
				end
			end
		}			
		toolbar.show
	end #end if
	
	
	$blb_bois_zmenu_BLB_Bois_loaded = true



