require 'Extensions'

def skp8_plugins_load()
	path_plug=Sketchup.find_support_file "Plugins"
	if File.exist?(File.join(path_plug,"Piece.rb")) || File.exist?(File.join(path_plug,"Piece.rbs")) 
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Piece','genere_piece.rbs')) end
	if File.exist?(File.join(path_plug,"Tenon&Mortaise.rb")) || File.exist?(File.join(path_plug,"Tenon&Mortaise.rbs"))
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Tenon_mortaise','usine_tenon_mortaise.rbs')) end
	if File.exist?(File.join(path_plug,"Face_reference.rb")) 
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Face_reference','faces_reference.rbs')) end
	if File.exist?(File.join(path_plug,"Usinage.rb")) || File.exist?(File.join(path_plug,"Usinage.rbs"))
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Usinage','usine_rfm.rbs')) end
	if File.exist?(File.join(path_plug,"Chapeau_gendarme.rb")) || File.exist?(File.join(path_plug,"Chapeau_gendarme.rbs"))  
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Chapeau_gendarme','usine_chapeau_gendarme.rbs')) end
	if File.exist?(File.join(path_plug,"Coupe.rb")) || File.exist?(File.join(path_plug,"Coupe.rbs"))
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Coupe','genere_coupe.rbs')) end
	if File.exist?(File.join(path_plug,"TenonM_renforce.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','TenonRenforce','usine_tm_r_ep.rbs')) end
	if File.exist?(File.join(path_plug,"Fiche_debit.rb")) || File.exist?(File.join(path_plug,"Fiche_debit.rbs"))
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Fiche_debit','genere_fiche_debit.rbs')) end
	if File.exist?(File.join(path_plug,"Rafale_TM.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Rafale_tenon','usine_rafale_tm.rbs')) end	
	if File.exist?(File.join(path_plug,"Assemblages.rb")) || File.exist?(File.join(path_plug,"Assemblage.rbs"))
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Assemblage','usine_assemblage.rbs')) end
	if File.exist?(File.join(path_plug,"Bouvetage.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Bouvetage','usine_bouvetage.rbs')) end
	if File.exist?(File.join(path_plug,"Usinage_contour.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Usinage_contour','usine_contour.rbs')) end
	if File.exist?(File.join(path_plug,"Aqueues.rb")) || File.exist?(File.join(path_plug,"Aqueues.rbs")) 
		then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Aqueues','usine_queues.rbs')) end
	if File.exist?(File.join(path_plug,"Systeme_32.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Systeme_32','usine_systeme_32.rbs')) end		
	if File.exist?(File.join(path_plug,"Aboutage.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Aboutage','usine_aboutage.rbs')) end		
	if File.exist?(File.join(path_plug,"Projection_2D.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Projection_2D','genere_projection_2d.rbs')) end		
	if File.exist?(File.join(path_plug,"Mise_en_page.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Mise_en_page','genere_mise_en_page.rbs')) end
	if File.exist?(File.join(path_plug,"Percage.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Percage','usine_percage.rbs')) end	
	if File.exist?(File.join(path_plug,"Caissons.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Caissons','genere_caissons.rbs')) end	
	if File.exist?(File.join(path_plug,"Bouvetage.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Bouvetage','usine_bouvetage.rbs')) end	
	if File.exist?(File.join(path_plug,"Systeme_Kreg.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Systeme_Kreg','usine_syst_kreg.rbs')) end
	if File.exist?(File.join(path_plug,"Vis.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Vis','assemblage_vis.rbs')) end
	if File.exist?(File.join(path_plug,"Quincaillerie.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Quincaillerie','ajout_quincaillerie.rbs')) end
	if File.exist?(File.join(path_plug,"Entaille.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Entaille','usine_entaille.rbs')) end
	if File.exist?(File.join(path_plug,"Etire.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Etire','do_stretching.rbs')) end
	if File.exist?(File.join(path_plug,"Chevillage.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Chevillage','usine_cheville.rbs')) end
	if File.exist?(File.join(path_plug,"Bouffetout.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','Bouffetout','usine_bouffetout.rbs')) end
	if File.exist?(File.join(path_plug,"BLB_starter.rb")) then Sketchup.load(File.join(path_plug,'BLB-Bois','Ressources','BLB_starter','BLB_menu_starter.rbs')) end
end


def item_generation(mess,comd,toolbar)
	t1,t2,t3,t4=decode_message(mess)
	path_icons=Sketchup.find_support_file "Plugins/BLB-Bois/Icons"
	jol_icons = File.join(path_icons,t1+'_s.png') 
	jol_iconl = File.join(path_icons,t1+'_L.png') 
	comd.small_icon = jol_icons 
	comd.large_icon = jol_iconl
	comd.tooltip = t2
	comd.status_bar_text = t3
	comd.menu_text = t4
	toolbar.add_item comd 
end

def decode_message(msg)

	posi=msg.index(",")
	t1=msg[0..posi-1]
	msg=msg[posi+1..msg.length-1]

	posi=msg.index(",")
	t2=msg[0..posi-1]
	msg=msg[posi+1..msg.length-1]

	posi=msg.index(",")
	t3=msg[0..posi-1]
	t4=msg[posi+1..msg.length-1]
	return t1,t2,t3,t4
end

def maj_menu_blb_bois()
	path_plugins=Sketchup.find_support_file "Plugins"
	f_read=path_plugins
	present_plugins=[]
	Dir.foreach(f_read) do |entry|
		file_found=entry
		posi = file_found.index(".rb")
		if !posi then posi = file_found.index(".rbs") end
		if posi 
			plugin_name=file_found[0..posi-1]
			add_plug=false
			if plugin_name=="Piece"
				if Object.const_defined?('Piece_generation') then add_plug=true end
			elsif plugin_name=="Tenon&Mortaise"
				if Object.const_defined?('Tenon_Mortaise') then add_plug=true end
			elsif plugin_name=="Usinage"
				if Object.const_defined?('Usinage') then add_plug=true end
			elsif plugin_name=="Chapeau_gendarme" 
				if Object.const_defined?('Chapeau_gendarme') || Object.const_defined?('Chapeau_Gendarme') then add_plug=true end
			elsif plugin_name=="Coupe"
				if Object.const_defined?('Coupe') || !Object.const_defined?('Coupe_2') then add_plug=true end
			elsif plugin_name=="Tenon_Renfort"
				if Object.const_defined?('Tenon_Renfort') then add_plug=true end
			elsif plugin_name=="Fiche_debit"
				if Object.const_defined?('Fiche_debit') then add_plug=true end
			elsif plugin_name=="Rafale_TM"
				if Object.const_defined?('Rafale_TM') then add_plug=true end
			elsif plugin_name=="Assemblage"
				if Object.const_defined?('Assemblage') && !Object.const_defined?('Assemblage_2') then add_plug=true end
			elsif plugin_name=="Assemblages"
				if Object.const_defined?('Assemblage_2') then add_plug=true end
			elsif plugin_name=="Bouvetage"	
				if Object.const_defined?('Bouvetage') then add_plug=true end
			elsif plugin_name=="Usinage_contour"
				if Object.const_defined?('Usinage_contour') then add_plug=true end
			elsif plugin_name=="Aqueues"
				if Object.const_defined?('Aqueues') then add_plug=true end
			elsif plugin_name=="Systeme_32"
				if Object.const_defined?('Systeme_32')  then add_plug=true end
			elsif plugin_name=="Systeme_kreg"
				if Object.const_defined?('Systeme_kreg') then add_plug=true end
			elsif plugin_name=="Mise_en_page"
				if Object.const_defined?('Mise_en_page') then add_plug=true end
			elsif plugin_name=="Quincaillerie"
				if Object.const_defined?('Quincaillerie') then add_plug=true end	
			elsif plugin_name=="Percage"						
				if Object.const_defined?('Percage') then add_plug=true end
			elsif plugin_name=="Caissons"				
				if Object.const_defined?('Caissons') then add_plug=true end
			elsif plugin_name=="Chevillage"				
				if Object.const_defined?('Chevillage') then add_plug=true end
			elsif plugin_name=="Etire"				
				if Object.const_defined?('Do_stretching') then add_plug=true end
			elsif plugin_name=="Vis"				
				if Object.const_defined?('Assemblage_vis') then add_plug=true end
			elsif plugin_name=="Entaille"				
				if Object.const_defined?('Entaille') then add_plug=true end
			elsif plugin_name=="Bouffetout"				
				if Object.const_defined?('Bouffetout') then add_plug=true end
			end
			if add_plug then present_plugins << plugin_name end 
		end
	end
	input_f= path_plugins+"/BLB-Bois/Ressources/Menu_BLB-Bois/Menu_BLB-Bois_param.txt"
	input_exist=File.exist?(input_f)
	if (input_exist.to_s=="true")
		f= File.open(input_f, "r") 
		libelle=[]
		f.each do |f_line|
			libelle<<f_line[0..(f_line.length-2)]	
		end  # do
		f.close
		output_f= path_plugins+"/BLB-Bois/Ressources/Menu_BLB-Bois/Menu_BLB-Bois_param.txt"
		f = File.new(output_f, "w") 
		libelle.each {|li| if present_plugins.index(li) then f.puts li.to_s end	}
		present_plugins.each {|p| if !libelle.index(p) then f.puts p.to_s end	}		
		f.close
	end	
end

def erase_old_versions()
	path_plug=Sketchup.find_support_file "Plugins"

	if File.exist?(File.join(path_plug,"Menu_BLB-Bois.rb")) then File.delete(File.join(path_plug,"Menu_BLB-Bois.rb")) end	
	if File.exist?(File.join(path_plug,"Menu_BLB-Bois.rbs")) then File.delete(File.join(path_plug,"Menu_BLB-Bois.rbs")) end
	# version=Sketchup.version
	# if version.to_i >16 && version[3].to_i>=1
		if File.exist?(File.join(path_plug,"Zmenu_BLB-Bois.rbs")) then File.delete(File.join(path_plug,"Zmenu_BLB-Bois.rbs")) end
	# else
		if File.exist?(File.join(path_plug,"Zmenu_BLB-Bois.rb")) then File.delete(File.join(path_plug,"Zmenu_BLB-Bois.rb")) end
	# end

	if File.exist?(File.join(path_plug,"Piece.rbs")) && File.exist?(File.join(path_plug,"Piece.rb")) then File.delete(File.join(path_plug,"Piece.rbs")) end	
	if File.exist?(File.join(path_plug,"Tenon&Mortaise.rbs")) && File.exist?(File.join(path_plug,"Tenon&Mortaise.rb")) 
		File.delete(File.join(path_plug,"Tenon&Mortaise.rbs"))
	end
	if File.exist?(File.join(path_plug,"Tenon&Mortaise.rb"))
		if File.exist?(File.join(path_plug,'Tenon&Mortaise.skp')) then File.delete(File.join(path_plug,'Tenon&Mortaise.skp')) end
		if File.exist?(File.join(path_plug,'Tenon&Mortaise.txt')) then File.delete(File.join(path_plug,'Tenon&Mortaise.txt')) end		
	end	
	
	if File.exist?(File.join(path_plug,"Usinage.rbs")) && File.exist?(File.join(path_plug,"Usinage.rb")) 
		File.delete(File.join(path_plug,"Usinage.rbs"))
	end
	if File.exist?(File.join(path_plug,"Usinage.rb")) 
		if File.exist?(File.join(path_plug,'Usinage.txt')) then File.delete(File.join(path_plug,'Usinage.txt')) end
		if File.exist?(File.join(path_plug,'Usinage.skp')) then File.delete(File.join(path_plug,'Usinage.skp')) end
		if File.exist?(File.join(path_plug,'USINAGE - Guide Utilisateur - v1.0.pdf')) then File.delete(File.join(path_plug,'USINAGE - Guide Utilisateur - v1.0.pdf')) end	
	end	
	
	if File.exist?(File.join(path_plug,"Chapeau_gendarme.rbs")) && File.exist?(File.join(path_plug,"Chapeau_gendarme.rb")) 
		File.delete(File.join(path_plug,"Chapeau_gendarme.rbs")) 
	end
	if File.exist?(File.join(path_plug,"Chapeau_gendarme.rb")) 
		if File.exist?(File.join(path_plug,'Chapeau_gendarme.skp')) then File.delete(File.join(path_plug,'Chapeau_gendarme.skp')) end		
		if File.exist?(File.join(path_plug,'Chapeau_gendarme.txt')) then File.delete(File.join(path_plug,'Chapeau_gendarme.txt')) end
		if File.exist?(File.join(path_plug,'Chapeau_de_gendarme.rb')) then File.delete(File.join(path_plug,'Chapeau_de_gendarme.rb')) end		
	end	
	
	if File.exist?(File.join(path_plug,"Coupe.rbs")) && File.exist?(File.join(path_plug,"Coupe.rb")) then File.delete(File.join(path_plug,"Coupe.rbs")) end	
	if File.exist?(File.join(path_plug,"Coupes.rb")) && File.exist?(File.join(path_plug,"Coupe.rb")) then File.delete(File.join(path_plug,"Coupes.rb")) end	
	
	if File.exist?(File.join(path_plug,"Fiche_debit.rbs")) && File.exist?(File.join(path_plug,"Fiche_debit.rb")) 
		File.delete(File.join(path_plug,"Fiche_debit.rbs")) 
	end
	if File.exist?(File.join(path_plug,"Fiche_debit.rb"))
		if File.exist?(File.join(path_plug,'Fiche_debit.txt')) then File.delete(File.join(path_plug,'Fiche_debit.txt')) end
	end	
	
	if File.exist?(File.join(path_plug,"Aqueues.rbs")) && File.exist?(File.join(path_plug,"Aqueues.rb")) 
		File.delete(File.join(path_plug,"Aqueues.rbs")) 
	end
	if File.exist?(File.join(path_plug,"Aqueues.rb")) 
		if File.exist?(File.join(path_plug,'BLB-Bois','Assemblage a queue - Guide Utilisateur - v1.0.pdf')) then File.delete(File.join(path_plug,'BLB-Bois','Assemblage a queue - Guide Utilisateur - v1.0.pdf')) end
		if  File.exist?(File.join(path_plug,'BLB-Bois','usine_queues.rbs')) then File.delete(File.join(path_plug,'BLB-Bois','usine_queues.rbs')) end
	end

	if File.exist?(File.join(path_plug,"Assemblages.rb"))
		if File.exist?(File.join(path_plug,'Assemblage.rbs')) then File.delete(File.join(path_plug,'Assemblage.rbs')) end
		if File.exist?(File.join(path_plug,'Assemblage.rb')) then File.delete(File.join(path_plug,'Assemblage.rb')) end
		if File.exist?(File.join(path_plug,'Assemblage.txt')) then File.delete(File.join(path_plug,'Assemblage.txt')) end
		if File.exist?(File.join(path_plug,'Assemblage.skp')) then File.delete(File.join(path_plug,'Assemblage.skp')) end	
	end	
end

